=== src/TKBinL/CMakeLists.txt ===
project(TKBinL)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
