=== src/ExpToCasExe/CMakeLists.txt ===
project(ExpToCasExe)

set (EXECUTABLE_PROJECT ON)
OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
unset (EXECUTABLE_PROJECT)
