=== src/TKBin/CMakeLists.txt ===
project(TKBin)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
