=== src/TKBinXCAF/CMakeLists.txt ===
project(TKBinXCAF)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
