=== src/TKBool/CMakeLists.txt ===
project(TKBool)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
