=== src/TKD3DHost/CMakeLists.txt ===
project(TKD3DHost)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
