=== src/TKDE/CMakeLists.txt ===
project(TKDE)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
