=== src/TKDEGLTF/CMakeLists.txt ===
project(TKDEGLTF)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
