=== src/TKDEOBJ/CMakeLists.txt ===
project(TKDEOBJ)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
