=== src/TKDEPLY/CMakeLists.txt ===
project(TKDEPLY)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
