=== debian/changelog ===
opencascade (7.9.1+dfsg-1~exp2) experimental; urgency=medium

  * Merge changes from unstable uploads 7.8.1+dfsg1-6 and -7:
    - libocct-visualization-dev - Depend on libocct-ivtk-dev (Closes: #1117410)
    - Change to VTK 9.5 (Closes: #1117518)

 -- Tobias Frost <tobi@debian.org>  Fri, 17 Oct 2025 20:59:46 +0200

opencascade (7.9.1+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Rename packages according to new upstream version.
  * Upload to experimental to clear NEW and prepare transition.
  * d/watch: use dfsg, not dfsg1 as suffix for orig.tar.
  * Prepare d/copyright Files-Excluded for new upstream version.
  * Drop patches, applied/fixed upstream or otherwise obsolete:
    - 0001-cmake-Don-t-try-to-write-to-install-directory.-You-k.patch
    - 0002-GeomPlate_BuildAveragePlane-BasePlan-Don-t-set-yvect.patch
    - 0005-BRepFill_Filling-Don-t-even-attempt-to-build-with-em.patch
    - 0013-use-auto-instead-of-specific-type.patch
    - fix-install-dir-references.diff
  * Refresh patches:
    - 0003-BRepFill_Filling-WireFromList-We-can-t-assume-that-a.patch
    - 0004-BRepFill_Filling-Curve-constraints-confused-by-impli.patch
    - 0006-BRepOffset_Tool-TryProject-Check-return-of-BRepLib-B.patch
    - 0010-fix-cmake-module.patch
    - 0011-cmake-workaround-tbbmemory.patch
    - 0012-cmake-do-not-export-ffile-prefix.patch
    - armel-ftbfs.patch
    - do-not-use-doxygen-searchengine.patch

 -- Tobias Frost <tobi@debian.org>  Tue, 14 Oct 2025 07:15:36 +0200
