## opencascade 7.9.2%2Bdfsg

=== debian/changelog ===
opencascade (7.9.2+dfsg-2) unstable; urgency=medium

  * Drop blobfish patches. (Closes: #1121362)

 -- Tobias Frost <tobi@debian.org>  Thu, 04 Dec 2025 06:05:00 +0100

opencascade (7.9.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * occt-draw: add Recommends: libocct-draw-dev so that draw will
    be able to load the modules on usual installation without manually
    installing the package. Closes: #1116171.

 -- Tobias Frost <tobi@debian.org>  Sat, 15 Nov 2025 12:06:26 +0100
